
//
// Academic License - for use in teaching, academic research, and meeting
// course requirements at degree granting institutions only.  Not for
// government, commercial, or other organizational use.
// File: kin_xyzbc_tt_J_tj.cpp
//
// MATLAB Coder version            : 5.4
//

// Include Files
#include "kin_xyzbc_tt_J_tj.h"
#include "coder_array.h"
#include <cmath>

// Function Definitions
//
// function J_tj = kin_xyzbc_tt_J_tj(in1,in2)
//
// kin_xyzbc_tt_J_tj
//     J_tj = kin_xyzbc_tt_J_tj(IN1,IN2)
//
// Arguments    : const ::coder::array<double, 1U> &in1
//                const ::coder::array<double, 1U> &in2
//                double J_tj[5][5]
// Return Type  : void
//
namespace ocn {
void kin_xyzbc_tt_J_tj(const ::coder::array<double, 1U> &in1, const ::coder::array<double, 1U> &in2,
                       double J_tj[5][5])
{
    double J_tj_tmp;
    double b_J_tj_tmp;
    double c_J_tj_tmp;
    double d_J_tj_tmp;
    double t10;
    double t11;
    double t2;
    double t3;
    double t4;
    double t5;
    double t9;
    //     This function was generated by the Symbolic Math Toolbox version 9.1.
    //     07-Nov-2023 14:54:34
    // Jacobian Kinematics ( Forward Kinematics ) :
    // INPUTS :
    // 	r_j    (5x1) : pose vector( joint space )
    // 	v_j    (5x1) : speed vector( joint space )
    // 	p      (3x5) : parameters
    // OUTPUTS :
    // 	M      (5x5) : resulting matrix
    // 'kin_xyzbc_tt_J_tj:16' b = in1(4,:);
    // 'kin_xyzbc_tt_J_tj:17' c = in1(5,:);
    // 'kin_xyzbc_tt_J_tj:18' offB1 = in2(10);
    // 'kin_xyzbc_tt_J_tj:19' offB2 = in2(11);
    // 'kin_xyzbc_tt_J_tj:20' offC1 = in2(13);
    // 'kin_xyzbc_tt_J_tj:21' offB3 = in2(12);
    // 'kin_xyzbc_tt_J_tj:22' offC2 = in2(14);
    // 'kin_xyzbc_tt_J_tj:23' offC3 = in2(15);
    // 'kin_xyzbc_tt_J_tj:24' offM1 = in2(1);
    // 'kin_xyzbc_tt_J_tj:25' offM2 = in2(2);
    // 'kin_xyzbc_tt_J_tj:26' offM3 = in2(3);
    // 'kin_xyzbc_tt_J_tj:27' offT1 = in2(4);
    // 'kin_xyzbc_tt_J_tj:28' offT2 = in2(5);
    // 'kin_xyzbc_tt_J_tj:29' offT3 = in2(6);
    // 'kin_xyzbc_tt_J_tj:30' x = in1(1,:);
    // 'kin_xyzbc_tt_J_tj:31' y = in1(2,:);
    // 'kin_xyzbc_tt_J_tj:32' z = in1(3,:);
    // 'kin_xyzbc_tt_J_tj:33' t2 = cos(b);
    t2 = std::cos(in1[3]);
    // 'kin_xyzbc_tt_J_tj:34' t3 = cos(c);
    t3 = std::cos(in1[4]);
    // 'kin_xyzbc_tt_J_tj:35' t4 = sin(b);
    t4 = std::sin(in1[3]);
    // 'kin_xyzbc_tt_J_tj:36' t5 = sin(c);
    t5 = std::sin(in1[4]);
    // 'kin_xyzbc_tt_J_tj:37' t6 = -offM1;
    // 'kin_xyzbc_tt_J_tj:38' t7 = -offM2;
    // 'kin_xyzbc_tt_J_tj:39' t8 = -offM3;
    // 'kin_xyzbc_tt_J_tj:40' t9 = offB1+offC1+offT1+t6+x;
    t9 = (((in2[9] + in2[12]) + in2[3]) + -in2[0]) + in1[0];
    // 'kin_xyzbc_tt_J_tj:41' t10 = offB2+offC2+offT2+t7+y;
    t10 = (((in2[10] + in2[13]) + in2[4]) + -in2[1]) + in1[1];
    // 'kin_xyzbc_tt_J_tj:42' t11 = offB3+offC3+offT3+t8+z;
    t11 = (((in2[11] + in2[14]) + in2[5]) + -in2[2]) + in1[2];
    // 'kin_xyzbc_tt_J_tj:43' J_tj =
    // reshape([t2.*t3,-t2.*t5,t4,0.0,0.0,t5,t3,0.0,0.0,0.0,-t3.*t4,t4.*t5,t2,0.0,0.0,-t2.*t3.*t11-t3.*t4.*t9,t2.*t5.*t11+t4.*t5.*t9,t2.*t9-t4.*t11,1.0,0.0,-offB2.*t3+offB1.*t5+t3.*t10-t2.*t5.*t9+t4.*t5.*t11,offB1.*t3+offB2.*t5-t5.*t10-t2.*t3.*t9+t3.*t4.*t11,0.0,0.0,1.0],[5,5]);
    J_tj_tmp = t2 * t3;
    J_tj[0][0] = J_tj_tmp;
    J_tj[0][1] = -t2 * t5;
    J_tj[0][2] = t4;
    J_tj[0][3] = 0.0;
    J_tj[0][4] = 0.0;
    J_tj[1][0] = t5;
    J_tj[1][1] = t3;
    J_tj[1][2] = 0.0;
    J_tj[1][3] = 0.0;
    J_tj[1][4] = 0.0;
    J_tj[2][0] = -t3 * t4;
    b_J_tj_tmp = t4 * t5;
    J_tj[2][1] = b_J_tj_tmp;
    J_tj[2][2] = t2;
    J_tj[2][3] = 0.0;
    J_tj[2][4] = 0.0;
    c_J_tj_tmp = t3 * t4;
    J_tj[3][0] = -t2 * t3 * t11 - c_J_tj_tmp * t9;
    d_J_tj_tmp = t2 * t5;
    J_tj[3][1] = d_J_tj_tmp * t11 + b_J_tj_tmp * t9;
    J_tj[3][2] = t2 * t9 - t4 * t11;
    J_tj[3][3] = 1.0;
    J_tj[3][4] = 0.0;
    J_tj[4][0] = (((-in2[10] * t3 + in2[9] * t5) + t3 * t10) - d_J_tj_tmp * t9) + b_J_tj_tmp * t11;
    J_tj[4][1] = (((in2[9] * t3 + in2[10] * t5) - t5 * t10) - J_tj_tmp * t9) + c_J_tj_tmp * t11;
    J_tj[4][2] = 0.0;
    J_tj[4][3] = 0.0;
    J_tj[4][4] = 1.0;
}

} // namespace ocn

//
// File trailer for kin_xyzbc_tt_J_tj.cpp
//
// [EOF]
//
